ToggleGroupFrame = {}

local addon = { name = "ToggleGroupFrame" }
local em = GetEventManager()
local groupFrameHidden = true
local showInCombat = true

ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_GROUP_FRAME", "Show/Hide group frame")
ZO_CreateStringId("SI_BINDING_NAME_TOGGLE_GROUP_FRAME_IN_COMBAT", "Show/Hide in combat")

function addon.OnAddOnLoaded(event, addonName)
   if addonName ~= addon.name then return end
   addon.Initialize()
end

function addon.Initialize()
   ZO_UnitFramesGroups:SetHidden(true)

   local savedVariables = ZO_SavedVars:New("ToggleGroupFrameSavedVariables", 1, nil, {}, GetWorldName())

   SLASH_COMMANDS['/togglegroupframe'] = function()
      groupFrameHidden = not groupFrameHidden
      ZO_UnitFramesGroups:SetHidden(groupFrameHidden)
      savedVariables.groupFrameHidden = groupFrameHidden
   end
   SLASH_COMMANDS['/tgf'] = SLASH_COMMANDS['/togglegroupframe']
   
   SLASH_COMMANDS['/togglegroupframeincombat'] = function()
      showInCombat = not showInCombat
      savedVariables.showInCombat = showInCombat
      addon.UpdateGroupFrameVisibility()
   end
   SLASH_COMMANDS['/tgfc'] = SLASH_COMMANDS['/togglegroupframeincombat']
   SLASH_COMMANDS['/tgfic'] = SLASH_COMMANDS['/togglegroupframeincombat']

   em:RegisterForEvent(addon.name, EVENT_PLAYER_COMBAT_STATE, addon.OnCombatStateChanged)
   em:UnregisterForEvent(addon.name, EVENT_ADD_ON_LOADED)
end

function addon.UpdateGroupFrameVisibility()
   if IsUnitInCombat("player") then
      if showInCombat then
         ZO_UnitFramesGroups:SetHidden(false)
      else
         ZO_UnitFramesGroups:SetHidden(true)
      end
   else
      ZO_UnitFramesGroups:SetHidden(groupFrameHidden)
   end
end

function addon.OnCombatStateChanged(event, inCombat)
   if not groupFrameHidden then
      return
   end

   addon.UpdateGroupFrameVisibility()
end

em:RegisterForEvent(addon.name, EVENT_ADD_ON_LOADED, addon.OnAddOnLoaded)